# -*- coding: utf-8 -*-
from setuphelpers import *
import waptguihelper
import json


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    data = json.loads(wgets("https://formulae.brew.sh/api/cask.json", proxies=proxies))
    prefix = control.package.split("-")[0]

    # Ask package once
    if "tis-template-homebrew" in control.package:
        hb_package = waptguihelper.grid_dialog("Homebrew packages", data, waptguihelper.GRT_SELECTED)[0]
    else:
        for p in data:
            if control.package.split(prefix + "-")[-1] in p["token"]:
                hb_package = p
                break
        control.categories = "Utilities"

        # Removing template files
        remove_file("WAPT\\changelog.txt")
        remove_file("WAPT\\icon.png")

    # Complete control
    control.name = hb_package["name"][0]
    control.package = prefix + "-" + hb_package["token"]
    control.description = hb_package["desc"]
    control.homepage = hb_package["homepage"]
    control.description = hb_package["desc"]
    if hb_package["conflicts_with"]:
        control.conflicts = ",".join([prefix + "-" + a.split("/")[-1] for a in hb_package["conflicts_with"]["cask"]])
    if hb_package["depends_on"]:
        control.min_os_version = hb_package["depends_on"]["macos"][">="][0]
    control.save_control_to_wapt()

    # Define variable for download
    latest_bin = hb_package["url"].rsplit("/", 1)[-1]
    version = hb_package["version"].replace("-", ".")
    download_url = hb_package["url"]

    # Downloading latest binaries
    print("Latest %s version is: %s" % (control.name, version))
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated
